"""
Time module
"""

import datetime
import json

import pytz

UTC = pytz.UTC

# portal_timezone = datetime.timezone(offset=datetime.timedelta(hours=1), name='UTC+1')

portal_timezone = pytz.timezone('Europe/Prague')


def NOW():
    return datetime.datetime.now(tz=portal_timezone)


def normalize_time(time):
    if hasattr(time, 'tzinfo') and time.tzinfo is not None:
        return time
    return portal_timezone.localize(time)


def strip_seconds(time):
    if not time:
        return time
    replaced = time.replace(second=0, microsecond=0)
    return normalize_time(replaced)


# source: https://stackoverflow.com/questions/11875770/how-to-overcome-datetime-datetime-not-json-serializable
class DateTimeEncoder(json.JSONEncoder):
    def default(self, o):
        if isinstance(o, datetime.datetime):
            return o.isoformat()

        return json.JSONEncoder.default(self, o)
